org.apache.tapestry5.services.compatibility

## Enum Trait

- java.lang.Object
- - java.lang.Enum<Trait>
  - - org.apache.tapestry5.services.compatibility.Trait

- All Implemented Interfaces:
    Serializable, Comparable<Trait>

      public enum Trait
      extends Enum<Trait>

  Defines different traits that may be enabled or disabled. This was introduced in Tapestry 5.4 to allow certain features that exist in Tapestry 5.3 to be optionally enabled for compatibility.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BOOTSTRAP_3` Indicates that Twitter Bootstrap 3 CSS and JavaScript should be included in all pages by default.
    `BOOTSTRAP_4` Indicates that Twitter Bootstrap 4 CSS and JavaScript should be included in all pages by default.
    `INITIALIZERS` Support for Tapestry 5.3 style initializers (the client-side `T5.initializers` namespace).
    `SCRIPTACULOUS` Indicates that the Scriptaculous JavaScript libraries should be included.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Trait` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static Trait[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### SCRIPTACULOUS

          public static final Trait SCRIPTACULOUS

      Indicates that the Scriptaculous JavaScript libraries should be included. Tapestry 5.3 includes options for performing some kinds of animations when certain elements were updated or removed; that is no longer present in Tapestry 5.4 and Scriptaculous is not used. This trait is only used if the JavaScript infrastructure provider is set to "prototype".

    - #### INITIALIZERS

          public static final Trait INITIALIZERS

      Support for Tapestry 5.3 style initializers (the client-side `T5.initializers` namespace).

    - #### BOOTSTRAP_3

          public static final Trait BOOTSTRAP_3

      Indicates that Twitter Bootstrap 3 CSS and JavaScript should be included in all pages by default.
      Since:
        5.5
      See Also:
        Bootstrap site

    - #### BOOTSTRAP_4

          public static final Trait BOOTSTRAP_4

      Indicates that Twitter Bootstrap 4 CSS and JavaScript should be included in all pages by default.
      Since:
        5.5
      See Also:
        Bootstrap site

  - ### Method Detail

    - #### values

          public static Trait[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Trait c : Trait.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Trait valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

5.6.0 - Copyright © 2003-2020 The Apache Software Foundation.